@echo Copy boost list of files...
@set TEMPR=boost-trunk
@set TEMPSRC=C:\FGCVS\%TEMPR%
@set TEMPIN=boostlist.txt

@if NOT EXIST %TEMPSRC%\boost\. goto ERR1
@if NOT EXIST %TEMPIN% goto ERR2
@set TEMPRET=%CD%
@set TEMPMIS=0
@set TEMPCNT=0
@set TEMPTOT=0
@set TEMPFOL=0
@set TEMPTDO=0
@echo Checking SOURCE of each... moment...
@for /F "tokens=1" %%i in (%TEMPIN%) do @(call :CHKIT %%i)
@echo Of total %TEMPTOT%, found %TEMPCNT%, missed %TEMPMIS%, folders %TEMPFOL%...
@if "%TEMPCNT%x" == "0x" goto NONEFND
@if "%TEMPTDO%x" NEQ "0x" goto DNTDO
@echo ************* NOTHING TO DO ****************
@echo *** NOTE EVERY FILE APPEARS TO BE THERE ***
@echo Abort if you do NOT want to re-copy, update the files...
:DNTDO
@echo If just some missed, and ok otherwise...
@echo *** CONTINUE? *** Ctrl+C to abort...
@pause
@echo *** ARE YOU SURE? *** Last chance... Ctrl+C to abort...
@pause

@if NOT EXIST %TEMPR%\. md %TEMPR%
@if NOT EXIST %TEMPR%\. goto ERR3
@cd %TEMPR%
@if NOT EXIST boost\. md boost
@if NOT EXIST boost\. goto ERR3B
@cd ..
@set TEMPMIS=0
@set TEMPCNT=0
@set TEMPTOT=0
@set TEMPFOL=0
@for /F "tokens=1" %%i in (%TEMPIN%) do @(call :COPYIT %%i)
@echo Of total %TEMPTOT%, found %TEMPCNT%, missed %TEMPMIS%, folders %TEMPFOL%...
@goto DONE

:CHKIT
@if "x%1" == "x" goto :EOF
@REM echo %1
@set TEMPFIL=%~nx1
@set TEMPPATH=%~p1
@set TEMPEXT=%~x1
@set /A TEMPTOT+=1
@if "%TEMPFIL%x" == "x" goto CHKFOLDER
@if "%TEMPEXT%x" == "x" goto CHKFOLDER
@REM echo %TEMPTOT%: [%TEMPPATH%] [%TEMPFIL%] [%TEMPEXT%]
@REM pause
@if NOT EXIST %TEMPSRC%\%1 goto MISSED
@set /A TEMPCNT+=1
@if EXIST %TEMPR%\%1 goto :EOF
@set /A TEMPTDO+=1
@goto :EOF

:CHKFOLDER
@REM echo FOLDER %1 (%TEMPPATH%)
@REM goto :EOF
@REM if NOT EXIST %1\. md %1
@REM if NOT EXIST %1\. goto ERR4
@REM cd %1
@REM cd %TEMPRET%
@set /A TEMPFOL+=1
@goto :EOF

:COPYIT
@if "x%1" == "x" goto :EOF
@set TEMPRF=%TEMPR%\%1
@REM echo %1
@set TEMPFIL=%~nx1
@cd %TEMPR%
@set TEMPPATH=%~p1
@cd %TEMPRET%
@set TEMPEXT=%~x1
@set /A TEMPTOT+=1
@if "%TEMPFIL%x" == "x" goto ISFOLDER
@if "%TEMPEXT%x" == "x" goto ISFOLDER
@echo %TEMPFIL% [%TEMPPATH%] [%1]
@if NOT EXIST %TEMPSRC%\%1 goto MISSED
@set /A TEMPCNT+=1
@cd %TEMPR%
@if NOT EXIST %TEMPPATH%\. md %TEMPPATH%
@if NOT EXIST %TEMPATH%\. goto ERR5
@cd %TEMPPATH%
copy %TEMPSRC%\%1 > nul
@REM pause
@cd %TEMPRET%
@if EXIST %TEMPR%\%1 goto :EOF
@echo NOT FOUND [%TEMPR%\%1]
@echo ERROR: COPY FAILED! Suggest ABORT! Ctrl+C to FIX problem
@pause
@goto :EOF

:ISFOLDER
@REM echo FOLDER %1 (%TEMPPATH%)
@REM goto :EOF
@cd %TEMPR%
@if NOT EXIST %1\. md %1
@if ERRORLEVEL 1 goto ERR4
@if NOT EXIST %1\. goto ERR4
@cd %TEMPRET%
@set /A TEMPFOL+=1
@goto :EOF

:MISSED
@echo Can NOT locate %TEMPSRC%\%1 ...
@set /A TEMPMIS+=1
@goto :EOF

:ERR1
@echo ERROR: Can NOT locate folder %TEMPSRC%\boost\.!
@goto CHECK
:ERR2
@echo ERROR: Can NOT locate file %TEMPIN%!
@goto CHECK
:ERR3
@echo ERROR: Unable to create directory boost-trunk...
@goto END
:ERR3B
@echo ERROR: Unable to create directory boost-trunk\boost...
@goto END
:ERR4
@echo ERROR: Unable to create directory %1...
@goto CRIT
:ERR5
@echo ERROR: Unable to create directory %TEMPPATH%...
@goto CRIT

:CRIT
@echo This is critical! Use Ctrl+C to ABORT, and manually create it, then run this batch again...
@pause
@echo An error will result if you continue! Use Ctrl+C to ABORT
@pause
@goto END

:CHECK
@echo Check name, location, and FIX this batch file %0 ...
@REM echo Use Ctrl+C to ABORT...
@REM pause
@goto END

:NONEFND
@echo ERROR: NONE of source found... Check this batch file, or %TEMPIN%...
@echo Can only ABORT, doing nothing...
@goto END

:DONE
@echo done...
:END
